describe('Javascript based templates', function() {
    var fs = require('fs-extra'),
        path = require("path"),
        pathDir = path.resolve(__dirname + '/../templates/javascript');

    it('Should exists a folder templates for javascript', function(done) {
        var dir = fs.existsSync(pathDir);
        dir.should.equal(true);
        done();
    });

    describe('Should validate folders inside javascript templates', function() {
        it('should exists a folder component', function(done) {
            var dir = fs.existsSync(pathDir + '/component');
            dir.should.equal(true);
            done();
        });
        describe('Should validate files inside the component folder', function() {
            it('should exists on component folder the file template.controller.js', function(done) {
                var dir = fs.existsSync(pathDir + '/component/template.controller.js');
                dir.should.equal(true);
                done();
            });
            it('should exists on component folder the file template.component.js', function(done) {
                var dir = fs.existsSync(pathDir + '/component/template.component.js');
                dir.should.equal(true);
                done();
            });
            it('should exists on component folder the file template.html', function(done) {
                var dir = fs.existsSync(pathDir + '/component/template.html');
                dir.should.equal(true);
                done();
            });
            it('should exists on component folder the file template.scss', function(done) {
                var dir = fs.existsSync(pathDir + '/component/template.scss');
                dir.should.equal(true);
                done();
            });
            it('should exists on component folder the file template.spec.js', function(done) {
                var dir = fs.existsSync(pathDir + '/component/template.spec.js');
                dir.should.equal(true);
                done();
            });
        });

        describe('Should validate files inside the service folder', function() {
            it('Should exists a folder service', function(done) {
                var dir = fs.existsSync(pathDir + '/service');
                dir.should.equal(true);
                done();
            });
            describe('Should validate files inside the service folder', function() {
                it('should exists on service folder the file template.service.js', function(done) {
                    var dir = fs.existsSync(pathDir + '/service/template.service.js');
                    dir.should.equal(true);
                    done();
                });
                it('should exists on service folder the file template.service.module.js', function(done) {
                    var dir = fs.existsSync(pathDir + '/service/template.service.module.js');
                    dir.should.equal(true);
                    done();
                });
                it('should exists on service folder the file template.service.spec.js', function(done) {
                    var dir = fs.existsSync(pathDir + '/service/template.service.spec.js');
                    dir.should.equal(true);
                    done();
                });
            });
        });

        describe('Should validate files inside the mocks folder', function() {
            it('Should exists a folder mocks', function(done) {
                var dir = fs.existsSync(pathDir + '/mocks');
                dir.should.equal(true);
                done();
            });
            describe('Should validate files inside the mocks folder', function() {
                it('should exists on mocks folder the file template.mocks.js', function(done) {
                    var dir = fs.existsSync(pathDir + '/mocks/template.mocks.js');
                    dir.should.equal(true);
                    done();
                });
            });
        });

    });

});
