var constants = require('./locales/en.json');
if (process.platform !== 'win32') {
    var osLocale = require('os-locale');
    osLocale(function(err, locale) {
        if (locale === 'es_ES') {
            constants = require('./locales/es.json');
        }
        if (locale === 'pt_PT') {
            constants = require('./locales/pt.json');
        }
    });
}

function getGlobalOptions(pathTemplates, pathTDD) {
    return {
        appDir: pathTemplates,
        base: './',
        testSpecDir: pathTemplates,
        serviceDir: pathTemplates
    };
}

function optionListTerminal() {
    return [{
        type: 'list',
        name: constants.optionList.NAME,
        message: constants.optionList.MESSAGE,
        choices: constants.optionList.CHOICES,
        default: constants.optionList.DEFAULT,
    }];
}

function componentTerminal() {
    return [{
        type: 'input',
        name: constants.component.FOLDER_NAME,
        message: constants.component.FOLDER_MESSAGE,
        default: constants.component.FOLDER_DEFAULT
    }, {
        type: 'input',
        name: constants.component.NGMODULE_NAME,
        message: constants.component.NGMODULE_MESSAGE,
        default: constants.component.NGMODULE_DEFAULT
    }, {
        type: 'input',
        name: constants.component.PATH_NAME,
        message: constants.component.PATH_MESSAGE,
        default: constants.component.PATH_DEFAULT
    }, {
        type: 'confirm',
        name: constants.component.TDD_NAME,
        message: constants.component.TDD_MESSAGE,
        default: constants.component.TDD_DEFAULT
    }];
}

function directiveTerminal() {
    return [{
        type: 'input',
        name: constants.directive.FOLDER_NAME,
        message: constants.directive.FOLDER_MESSAGE,
        default: constants.directive.FOLDER_DEFAULT
    }, {
        type: 'input',
        name: constants.directive.NGMODULE_NAME,
        message: constants.directive.NGMODULE_MESSAGE,
        default: constants.directive.NGMODULE_DEFAULT
    }, {
        type: 'input',
        name: constants.directive.PATH_NAME,
        message: constants.directive.PATH_MESSAGE,
        default: constants.directive.PATH_DEFAULT
    }, {
        type: 'confirm',
        name: constants.directive.TDD_NAME,
        message: constants.directive.TDD_MESSAGE,
        default: constants.directive.TDD_DEFAULT
    }];
}

function ngServiceTerminal() {
    return [{
        type: 'input',
        name: constants.ngService.FOLDER_NAME,
        message: constants.ngService.FOLDER_MESSAGE,
        default: constants.ngService.FOLDER_DEFAULT
    }, {
        type: 'confirm',
        name: constants.ngService.TDD_NAME,
        message: constants.ngService.TDD_MESSAGE,
        default: constants.ngService.TDD_DEFAULT
    }, {
        type: 'input',
        name: constants.ngService.PATH_NAME,
        message: constants.ngService.PATH_MESSAGE,
        default: constants.ngService.PATH_DEFAULT
    }];
}

function mockServiceTerminal() {
    return [{
        type: 'input',
        name: constants.mockService.FOLDER_NAME,
        message: constants.mockService.FOLDER_MESSAGE,
        default: constants.mockService.FOLDER_DEFAULT
    }, {
        type: 'input',
        name: constants.mockService.PATH_NAME,
        message: constants.mockService.PATH_MESSAGE,
        default: constants.mockService.PATH_DEFAULT
    }];
}

var util = {
    getGlobalOptions: getGlobalOptions,
    optionListTerminal: optionListTerminal,
    componentTerminal: componentTerminal,
    directiveTerminal: directiveTerminal,
    ngServiceTerminal: ngServiceTerminal,
    mockServiceTerminal: mockServiceTerminal
};

module.exports = util;
